package org.q.app.engine.convert;

import java.util.Collection;

import org.q.toolkit.convert.Converter;
import org.q.toolkit.convert.Converters;
import org.q.toolkit.convert.construct.MapConstructor;
import org.q.toolkit.lang.collection.NewCollection;

import com.google.inject.Provider;

/**
 * Guice {@link Provider} for all available {@link Converter}'s.
 * 
 * @author Erik Lievaart
 */
public class PluginConvertersProvider implements Provider<Converters> {

	@Override
	public Converters get() {
		Converter<?> list = new ListConstructor(' ').createConverter();
		Converter<?> map = new MapConstructor().createConverter();

		Collection<Converter<?>> basic = new BasicConvertersProvider().get().listConverters();
		java.util.List<Converter<?>> converters = NewCollection.list();
		converters.addAll(basic);
		converters.add(list);
		converters.add(map);

		return new Converters(converters);
	}
}
