package org.q.app.engine.convert;

import java.io.IOException;

import org.q.app.vfs.UrlResolver;
import org.q.app.vfs.VirtualFile;
import org.q.toolkit.convert.construct.AbstractConstructor;
import org.q.toolkit.io.RuntimeIOException;
import org.q.toolkit.lang.Str;

class VirtualFileConstructor extends AbstractConstructor<VirtualFile> {

	@Override
	public VirtualFile constructObject(final String str) {
		try {
			return UrlResolver.resolve(str);
		} catch (IOException e) {
			throw new RuntimeIOException(Str.sub("Cannot create VirtualFile from url %, %", str, e.getMessage()), e);
		}
	}

}
