package org.q.app.ui.bind;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;

import org.q.app.engine.impl.Engine;
import org.q.app.engine.impl.Engine.Core;
import org.q.app.engine.impl.ErrorScript;

import com.google.inject.Inject;
import com.google.inject.Provider;

class EngineActionFactory {

	@Inject
	@Core
	private Provider<Engine> engine;
	@Inject
	private ErrorScript errorScript;

	Action createEngineAction(final String command) {
		return new AbstractAction() {
			@Override
			public void actionPerformed(final ActionEvent ae) {
				try {
					engine.get().invoke(command);
				} catch (Exception e) {
					errorScript.invoke("", e);
				}
			}
		};
	}
}
