package org.q.app.ui.bind.menu;

import javax.swing.JMenuBar;

import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Factory class for building a {@link JMenuBar}. This class should be used as a prototype.
 * 
 * @author Erik Lievaart
 */
public class JMenuBarBuilder implements ComponentBuilder<JMenuBar> {

	private final JMenuBar instance = new JMenuBar();

	@Override
	public void addChild(final ComponentBuilder<?> factory) {
		instance.add(factory.instance());
	}

	@Override
	public JMenuBar instance() {
		return instance;
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this);
	}

}
