package org.q.app.ui.context;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.q.app.vfs.VirtualFile;
import org.q.toolkit.lang.Check;

/**
 * Context object for a single file browser list.
 * 
 * @author Erik Lievaart
 */
public class UIContext {
	private VirtualFile location;

	protected UIContext() {
	}

	/**
	 * Get the directory currently shown.
	 */
	public VirtualFile getDir() {
		return location;
	}

	/**
	 * Set the directory currently shown.
	 */
	public void setDir(final VirtualFile file) {
		Check.isTrue(file.isDirectory(), "Not a directory: %", file);
		location = file;
	}

	@Override
	public String toString() {
		return new ToStringBuilder(this).append("dir", getDir()).toString();
	}

}
