package org.q.app.ui.render.icons;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

/**
 * Draws two colored rectangles (as pillars).
 * 
 * @author Erik Lievaart
 */
public class PauseIcon extends QIcon {

	/**
	 * Constructor.
	 * 
	 * @param size
	 *            width and height of the box bounding the icon.
	 * @param color
	 *            Color to use to paint the icon.
	 */
	public PauseIcon(final int size, final Color color) {
		super(size, color);
	}

	@Override
	public void paintIcon(final Component c, final Graphics g, final int x, final int y) {
		g.setColor(getColor());
		int w3d = getIconWidth() / 3;
		g.fillRect(x, y, w3d, getIconHeight());
		g.fillRect(x + 2 * w3d, y, w3d, getIconHeight());
	}
}
