package org.q.app.ui.render.terminal;

import org.q.app.general.DetailMessage;
import org.q.toolkit.runtime.CommandOutput;

import com.google.inject.Inject;

/**
 * Writes normal (non-error) messages from native the command line to the terminal using a Beanshell script.
 * 
 * @author Erik Lievaart
 */
public class TerminalOutput implements CommandOutput {
	@Inject
	private TerminalScript script;

	private TerminalOutput() {
	}

	@Override
	public void println(final String msg) {
		script.addMessage(DetailMessage.message(msg));
	}

}
