package org.q.toolkit.convert.construct;

import java.util.Map;

import org.q.toolkit.convert.Converter;
import org.q.toolkit.convert.validate.MapValidator;
import org.q.toolkit.lang.collection.NewCollection;
import org.q.toolkit.lang.pattern.PatternTool;

/**
 * Constructs Map's from String's. Use '|' to separate entries and '=' to separate key - value pairs.
 * 
 * @author Erik Lievaart
 */
@SuppressWarnings("unchecked")
public class MapConstructor extends AbstractConstructor<Map> {

	@Override
	public Map<?, ?> constructObject(final String str) {
		Map map = NewCollection.map();
		for (String entry : PatternTool.split("#", str)) {
			String[] split = PatternTool.split("=", entry);
			map.put(split[0], split[1]);
		}
		return map;
	}

	@Override
	public Converter<Map> createConverter() {
		return createConverter(new MapValidator());
	}
}
