package org.q.toolkit.lang;

import java.util.Map;

import org.apache.commons.lang3.ArrayUtils;
import org.q.toolkit.lang.pattern.PatternTool;
import org.q.toolkit.reflect.PropertyTool;
import org.q.toolkit.reflect.method.PropertyWrapper;

public class BeanProperties {

	public static Object resolveProperty(String property, Map<String, ?> primary, Map<String, ?>... secondary) {
		String[] path = PatternTool.split("\\.", property.trim());

		Object bean = resolveBean(path[0], primary, secondary);
		Check.notNull(bean, "% is <null> for EL:%", path[0], property);

		for (int i = 1; i < path.length; i++) {
			Map<String, PropertyWrapper> props = PropertyTool.getPropertyMap(bean.getClass());
			Check.isTrue(props.containsKey(path[i]), "% not found on % for %", path[i], bean.getClass(), property);
			bean = props.get(path[i]).getAccessor(bean).invoke();
		}
		return bean;
	}

	private static Object resolveBean(String bean, Map<String, ?> primary, Map<String, ?>... secondary) {
		if (primary.containsKey(bean)) {
			return primary.get(bean);
		}
		if (secondary.length != 0) {
			return resolveBean(bean, secondary[0], ArrayUtils.subarray(secondary, 1, secondary.length));
		}
		return null;
	}
}
