package org.q.toolkit.runtime;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

class StreamRunnable implements Runnable {

	private final BufferedReader reader;
	private final CommandOutput err;
	private final CommandOutput out;

	public StreamRunnable(final InputStream input, final CommandOutput out, final CommandOutput err) {
		this.err = err;
		this.out = out;
		reader = new BufferedReader(new InputStreamReader(input));
	}

	@Override
	public void run() {
		try {
			String message = reader.readLine();
			while (message != null) {
				out.println(message);
				message = reader.readLine();
			}

		} catch (Exception e) {
			err.println("Reading stream interrupted: " + e.getMessage());
		}
	}
}
